package org.simantics.db.common.issue;

import java.util.Collection;

import org.simantics.databoard.Bindings;
import org.simantics.db.Resource;
import org.simantics.db.WriteGraph;
import org.simantics.db.exception.DatabaseException;
import org.simantics.layer0.Layer0;


public class IssueWithDescription extends AnonymousIssue {

    public final String description;

    public IssueWithDescription(Resource type, String description, Collection<Resource> contexts) {
        super(type, contexts);
        this.description = description;
    }

    public IssueWithDescription(Resource type, String description, Resource... contexts) {
        super(type, contexts);
        this.description = description;
    }
    
    @Override
    public Resource write(WriteGraph graph, Resource source)
            throws DatabaseException {
        Resource issue = super.write(graph, source);
        Layer0 L0 = Layer0.getInstance(graph);
        graph.claimLiteral(issue, L0.HasDescription, description, Bindings.STRING);
        return issue;
    }
    
}
